<?php
declare(strict_types = 1);

namespace RapidData\ContaoDynamicFormsBundle\Fragment;

use Contao\FormFieldModel;
use Contao\System;
use Contao\Widget;
use RapidData\ContaoDynamicFormsBundle\Fragment\Reference\FormFieldReference;

class FormFieldProxy extends Widget
{
    public function __construct($arrAttributes = null)
    {
        parent::__construct($arrAttributes);
    }

    /**
     * @inheritDoc
     */
    public function parse($arrAttributes=null)
    {
        $reference = new FormFieldReference(FormFieldModel::findById($this->strId));
        // @phpstan-ignore-next-line
        if ('BE' === TL_MODE)
        {
            $reference->setBackendScope();
        }

        return System::getContainer()->get('fragment.handler')->render($reference);
    }

    public function generate()
    {
        return $this->parse();
    }

    public function validate()
    {
        parent::validate(); // TODO: Change the autogenerated stub
    }
}

class_alias(FormFieldProxy::class, 'FormFieldProxy');
